# hestonpy

The `hestonpy` Python package implements the Heston and Black-Scholes models for option pricing and portfolio management. The package also includes functionality for optimal portfolio allocation using stochastic control techniques.

Covered topics by the `hestonpy` package:
1. path simulations
2. pricing plain european vanilla options
3. asset allocations (stochastic optimal control under Heston dynamics)
4. [TO DO] model calibration (smile, term structure) from yahoo finance and personnal data

## Installation
`hestonpy` is now avalaible on PyPi !
```bash
pip install hestonpy
```

## Contributing

Interested in contributing? Check out the contributing guidelines. Please note that this project is released with a Code of Conduct. By contributing to this project, you agree to abide by its terms.

## License

`hestonpy` was created by SarcasticMatrix. It is licensed under the terms of the MIT license.

## Credits

`hestonpy` was created with [`cookiecutter`](https://cookiecutter.readthedocs.io/en/latest/) and the `py-pkgs-cookiecutter` [template](https://github.com/py-pkgs/py-pkgs-cookiecutter).
